﻿using Checkboxes.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Checkboxes.Controllers
{
    public class SubscriptionController : Controller
    {		
		public ActionResult Choose()
		{
			SubscriptionModel emptyModel = new SubscriptionModel();
			return View(emptyModel);
		}

        public ActionResult Finalize(SubscriptionModel model)
        {
            return View(model);
        }

		public ActionResult ChooseMagazines()
		{
			MagazineSubscriptionModel model = new MagazineSubscriptionModel();
			model.Magazines = GetMagazines();
			return View(model);
		}

		public ActionResult FinalizeMagazines(MagazineSubscriptionModel model)
		{
			int temp = 0;
			IEnumerable<int> selectedIds = model.SelectedMagazineIds.Where(id => int.TryParse(id, out temp)).Select(i => temp).ToList();
			model.Magazines = GetMagazines().Where(m => selectedIds.Contains(m.Id)).ToList();
			return View(model);
		}

		private IEnumerable<Magazine> GetMagazines()
		{
			return new Magazine[] { 
				new Magazine { Id = 1, Name = "Visual Basic Programmer's Journal", Cost = 10 },
				new Magazine { Id = 2, Name = "Popular Science", Cost = 14 },
				new Magazine { Id = 3, Name = "Omni", Cost = 12 },
				new Magazine { Id = 4, Name = "MSDN", Cost = 10 }
			};
		}
    }
}